> For the complete documentation index, see [llms.txt](https://docs.payum.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.payum.dev/v2/symfony/debugging.md).

# Debugging

### Debug payment

This could be helpful when you want to find out what actions were added to payment and in which order. Also it will show extensions and apis added too.

```bash
$ php bin/console debug:payum:gateway
```

### Logs

Whenever you have problems, or want to understand Payum internals: *check the log file*. It contains the whole stack of called actions including details about a request and a model.

***Note:** The profiler allows to choose from up to 10 last http requests. So find desired one and check the logs section.*

***Note:** This log is available since symfony 2.2 because it is where psr-3 logger support was added.*

Here's an example of paypal execution before you are redirected to paypal side.

```
DEBUG - [Payum] 1# Payum\Core\Action\ExecuteSameRequestWithModelDetailsAction::execute(Capture{model: Token})
DEBUG - [Payum] 2# Payum\Paypal\ExpressCheckout\Nvp\Action\CaptureAction::execute(Capture{model: PaymentDetails})
DEBUG - [Payum] 3# Payum\Paypal\ExpressCheckout\Nvp\Action\Api\SetExpressCheckoutAction::execute(SetExpressCheckout{model: ArrayObject})
DEBUG - [Payum] 3# Payum\Paypal\ExpressCheckout\Nvp\Action\Api\AuthorizeTokenAction::execute(AuthorizeToken{model: ArrayObject})
DEBUG - [Payum] 3# AuthorizeTokenAction::execute(AuthorizeTokenRequest{model: ArrayObject}) throws reply HttpRedirect{url: https://www.sandbox.paypal.com/cgi-bin/webscr?cmd=_express-checkout&token=EC-86848505A5250314X}
DEBUG - [Payum] 2# CaptureAction::execute(Capture{model: PaymentDetails}) throws reply HttpRedirect{url: https://www.sandbox.paypal.com/cgi-bin/webscr?cmd=_express-checkout&token=EC-86848505A5250314X}
DEBUG - [Payum] 1# ExecuteSameRequestWithModelDetailsAction::execute(SecuredCaptur{model: PaymentDetails}) throws reply HttpRedirect{url: https://www.sandbox.paypal.com/cgi-bin/webscr?cmd=_express-checkout&token=EC-86848505A5250314X}
```

This stack of executed action when you come back from paypal side and finish the capture.

```
DEBUG - [Payum] 1# Payum\Core\Action\ExecuteSameRequestWithModelDetailsAction::execute(Capture{model: Token})
DEBUG - [Payum] 2# Payum\Paypal\ExpressCheckout\Nvp\Action\CaptureAction::execute(Capture{model: PaymentDetails})
DEBUG - [Payum] 3# Payum\Paypal\ExpressCheckout\Nvp\Action\PaymentDetailsSyncAction::execute(Sync{model: ArrayObject})
DEBUG - [Payum] 4# Payum\Paypal\ExpressCheckout\Nvp\Action\Api\GetExpressCheckoutDetailsAction::execute(GetExpressCheckoutDetails{model: ArrayObject})
DEBUG - [Payum] 3# Payum\Paypal\ExpressCheckout\Nvp\Action\Api\DoExpressCheckoutPaymentAction::execute(DoExpressCheckoutPayment{model: ArrayObject})
DEBUG - [Payum] 3# Payum\Paypal\ExpressCheckout\Nvp\Action\PaymentDetailsSyncAction::execute(Sync{model: ArrayObject})
DEBUG - [Payum] 4# Payum\Paypal\ExpressCheckout\Nvp\Action\Api\GetExpressCheckoutDetailsAction::execute(GetExpressCheckoutDetails{model: ArrayObject})
DEBUG - [Payum] 4# Payum\Paypal\ExpressCheckout\Nvp\Action\Api\GetTransactionDetailsAction::execute(GetTransactionDetails{model: ArrayObject})
```

***

### Supporting Payum

Payum is an MIT-licensed open source project with its ongoing development made possible entirely by the support of community and our customers. If you'd like to join them, please consider:

* [Become a sponsor](https://github.com/sponsors/Payum)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.payum.dev/v2/symfony/debugging.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
